#include<ncurses.h>
#include<malloc.h>
#include<stdlib.h>
#include<stdio.h>
#include<string.h>
int X1 , Y1, X2, Y2,insmd;char flname[20],flnamet[20],b;
int i1,x,y,x3,wi,wmax,flagx,flagm;chtype ch,ch1;
FILE *f;
struct node
{
	char c;
	struct node *left,*right;
};
typedef struct node * NODE;
NODE head,tail,temp;
NODE dispptr,nptr,mtemp;
WINDOW *w1,*wm,*w2;
void freenodes()
{
	NODE temp1,temp2;
	temp1=temp2=head->right;
	while(temp2!=tail)
	{temp2=temp2->right;
	free(temp1);
	temp1=temp2;}
	head->right=tail;
	tail->left=head;
	dispptr=nptr=head->right;
}
int movedown()
{
	while(mtemp!=tail&&mtemp->c!='\n')
		mtemp=mtemp->right;
	if(mtemp==tail)
		return(0);
	else
	{  mtemp=mtemp->right; return(1); }
}
void display()
{
	NODE dtptr;
	int x2,y2,flagd=0,flagn=0;
	dtptr=dispptr;
	x2=X1;
	x=X1;
	y2=Y1;
	y=Y1+1;
	attrset(COLOR_PAIR(1));
	bkgdset(' '|COLOR_PAIR(1));/*attron(A_BOLD);*/
	erase();
	while(((dtptr!=tail)&&(x2<=X2))&&flagd==0)
	{
		if(y2>Y2)
		{
			x2++; 
			y2=Y1;
		}
		
		if(dtptr==nptr)
		{	flagn=1;
			x=x2; 
			y=y2;
		}
		if(dtptr->c=='\n')
		{
			
			x2++; 
			y2=Y1;
		}
		
		if(x2>X2)
		{	
			flagd=1;
		}	
		else
		{  
			if(dtptr->c!='\n')
			{
				if(dtptr->c!='\t')
		{
			move(x2,y2);
			addch(dtptr->c);
			y2++;
		}
			}
		if(dtptr->c=='\t')
		{	
			y2=y2+8;   
		}
		dtptr=dtptr->right;
		}
	}
	if(nptr==tail&&flagd==0)
	{
		y=y2;
		x=x2;
		flagn=1;
	}
	if(flagn==0)
	{
		mtemp=dispptr;
		movedown();
		dispptr=mtemp;
		display();
	}
	attrset(COLOR_PAIR(2));
	mvaddstr(1,1,"  File             Edit                 Page_setup                  Help      ");
	i1=0;
	while(i1<COLS-79){addch(' ');
		i1++;
	}
	attrset(COLOR_PAIR(1));
	box(stdscr,0,0);
	mvaddch(0,(COLS/2)-5,'[');
	addstr(flname);
	addch(']');
	if(flagm==1)
		addch('*');
	mvaddstr(0,COLS-13,"A_EDIT");
	mvaddstr(LINES-1,6,"<ctrl-F>:MENU");
	if(insmd==1)mvaddstr(LINES-1,COLS-20,"MODE:[INSERT]");
	else mvaddstr(LINES-1,COLS-20,"MODE:[REPLACE]");
	move(x,y);
	
}

void insertnode(NODE temp,char a)
{
	NODE temp1;
	temp1=(struct node *) malloc(sizeof(struct node));
	
	temp1->left=temp;
	temp1->right=temp->right;
	temp->right->left=temp1;
	temp->right=temp1;
	temp1->c=temp->c;
	temp->c=a;
	if(temp==tail)
	tail=temp1;
}
	
void positionptr()
{
	int i;
	i=Y1;
	while(i<y)
	{
		if(mtemp->c!='\n'&&mtemp!=tail)
		{
			if(mtemp->c=='\t') 
				i=i+7;
			mtemp=mtemp->right;
				i++;
		}
		else 
		{
			y=i;
			return;
		}
	}
	if(i<Y2) 
		y=i;
	else   
		y=Y2;
}
void savfile()
{	w2=newwin(3,49,10,13);
	wattrset(w2,COLOR_PAIR(2));
	wbkgdset(w2,' '|COLOR_PAIR(2));
	wclear(w2);
	box(w2,0,0);
	mvwaddstr(w2,1,1,"File not saved..save?(y/n)");
	wrefresh(w2);
	echo();
	b=wgetch(w2);
	noecho();
	delwin(w2);
	clear();
	display();
	refresh();
	if(b=='y'||b=='Y')
	{f=fopen(flname,"w+");
			if(f!=NULL)
			{ 	
				flagm=0;
				temp=head->right;
			while(temp!=tail)
			{	
				putc(temp->c,f);
				temp=temp->right;
			}
			fclose(f);
			}
	}
}
void aboutbox()
{	w2=newwin(11,43,6,16);
	wattrset(w2,COLOR_PAIR(2));
	wbkgdset(w2,' '|COLOR_PAIR(2));
	wclear(w2);
	
	mvwaddstr(w2,1,1,"               \n");
	waddstr(w2,"  Author:  \n");
	waddstr(w2,"         A_EDIT is a small and lightweight \n");
	waddstr(w2,"   text editor for UNIX/LINUX platform\n");
	waddstr(w2,"                    ");
	box(w2,0,0);wrefresh(w2);wgetch(w2);
	delwin(w2);
}
void drawwin(int wim)
{	
	mvaddstr(LINES-1,6,"<CTRL-F>:CLOSE MENU");
	refresh();
	switch(wim)
	{
		case 1: wm=newwin(8,11,2,2);
		wattrset(wm,COLOR_PAIR(3));
			wbkgdset(wm,' '|COLOR_PAIR(3));
		wclear(wm);
		if(x3==1)
			wattron(wm,A_REVERSE);
			mvwaddstr(wm,1,1,"New     ");
			wattroff(wm,A_REVERSE);
		if(x3==2)
			wattron(wm,A_REVERSE);
			mvwaddstr(wm,2,1,"Open    ");
			wattroff(wm,A_REVERSE);
		if(x3==3)
			wattron(wm,A_REVERSE);
			mvwaddstr(wm,3,1,"Save    ");
			wattroff(wm,A_REVERSE);
		if(x3==4)
			wattron(wm,A_REVERSE);
			mvwaddstr(wm,4,1,"Save..as");
			wattroff(wm,A_REVERSE);
		if(x3==5)
			wattron(wm,A_REVERSE);
			mvwaddstr(wm,5,1,"Delete  ");
			wattroff(wm,A_REVERSE);
		if(x3==6)
			wattron(wm,A_REVERSE);
			mvwaddstr(wm,6,1,"Exit    ");
			wattroff(wm,A_REVERSE);
		wmax=6;
		box(wm,0,0);
		wmove(wm,x3,9);
		wrefresh(wm);
		break;
	case 2: wm=newwin(5,11,2,17);
		wattrset(wm,COLOR_PAIR(3));
		wbkgdset(wm,' '|COLOR_PAIR(3));
		wclear(wm);
		if(x3==1)
			wattron(wm,A_REVERSE);
			mvwaddstr(wm,1,1,"Ins_line");
			wattroff(wm,A_REVERSE);
		if(x3==2)
			wattron(wm,A_REVERSE);
			mvwaddstr(wm,2,1,"Del_line");
			wattroff(wm,A_REVERSE);
		if(x3==3)
			wattron(wm,A_REVERSE);
			mvwaddstr(wm,3,1,"Delword ");
			wattroff(wm,A_REVERSE);
		wmax=3;
		box(wm,0,0);
		wmove(wm,x3,9);
		wrefresh(wm);
		break;
	case 3: wm=newwin(6,15,2,39);
		wattrset(wm,COLOR_PAIR(3));
		wbkgdset(wm,' '|COLOR_PAIR(3));
		wclear(wm);
		if(x3==1)
			wattron(wm,A_REVERSE);
			mvwaddstr(wm,1,1,"Left_margin ");
			wattroff(wm,A_REVERSE);
		if(x3==2)
			wattron(wm,A_REVERSE);
			mvwaddstr(wm,2,1,"Right_margin");
			wattroff(wm,A_REVERSE);
		if(x3==3)
			wattron(wm,A_REVERSE);
			mvwaddstr(wm,3,1,"Begin       ");
			wattroff(wm,A_REVERSE);
		if(x3==4)
			wattron(wm,A_REVERSE);
			mvwaddstr(wm,4,1,"End         ");
			wattroff(wm,A_REVERSE);
		wmax=4;
		box(wm,0,0);
		wmove(wm,x3,13);
		wrefresh(wm);
		break;
	case 4: wm=newwin(4,11,2,66);
		wattrset(wm,COLOR_PAIR(3));
		wbkgdset(wm,' '|COLOR_PAIR(3));
		wclear(wm);
		if(x3==1)
			wattron(wm,A_REVERSE);
			mvwaddstr(wm,1,1,"Contents");
			wattroff(wm,A_REVERSE);
		if(x3==2)
			wattron(wm,A_REVERSE);
			mvwaddstr(wm,2,1,"About   ");
			wattroff(wm,A_REVERSE);
		wmax=2;
		box(wm,0,0);
		wmove(wm,x3,9);
		wrefresh(wm);
		break;		
	}
	
}
		
main(int argc,char * argv[])
{
	
	
	int i;
	char a;
	
	
head=(NODE) malloc(sizeof(struct node));
tail=(NODE) malloc(sizeof(struct node));

head->c=tail->c='0';
head->right=head->left=tail;
tail->left=tail->right=head;

dispptr=head->right;
nptr=head->right;
insmd=1;
flagm=0;
	if(argc>1)
	{ 
		strcpy(flname,argv[1]);
		f=fopen(flname,"r");
		temp=head->right;
	if(f!=NULL)
	{
	while((a=getc(f))!=EOF)
		{
			insertnode(temp,a);temp=temp->right;
		}
	fclose(f);
	}
	}
	else
		strcpy(flname,"noname.txt");
	
	initscr();
	start_color();
	init_pair(1,COLOR_WHITE,COLOR_BLUE);
	init_pair(2,COLOR_RED,COLOR_CYAN);
	init_pair(3,COLOR_RED,COLOR_WHITE);
	noecho();
	X1=2;  Y1=1;
	X2=LINES-2;Y2=COLS-2;
	x=X1;  y=Y1;
	dispptr=head->right;
	nptr=head->right;	
	display();
	refresh();
	aboutbox();
	clear();
	display();
	keypad(stdscr,TRUE);
	while(1)
	{
		ch=getch();
		
		switch(ch)
		{
			case KEY_RIGHT :if(nptr!=tail)
						nptr=nptr->right;
						display();
						break;
			case KEY_LEFT :	if(x!=X1||y!=Y1)
					{
				 		nptr=nptr->left;
						display();
					}
					break;
			case KEY_UP :if(x==X1)
					{
					if(dispptr->left!=head)
					 {
					dispptr=dispptr->left;
					mtemp=dispptr;
			while(mtemp->left!=head&&mtemp->left->c!='\n')
				mtemp=mtemp->left;
				nptr=dispptr=mtemp;
				positionptr();
				nptr=mtemp;
				}
			}
			else
			{
			  mtemp=nptr;
			while(mtemp->left!=head&&mtemp->left->c!='\n')
				mtemp=mtemp->left;
				mtemp=mtemp->left;
			while(mtemp->left!=head&&mtemp->left->c!='\n')
				mtemp=mtemp->left;
				positionptr();
				nptr=mtemp;
			}
			display();
			break;
			case KEY_DOWN :	
					mtemp=nptr;
					if(movedown())
					{
						positionptr();
						nptr=mtemp;
					}
						display();
						break;
			case KEY_BACKSPACE :if(x==X1&&(y==Y1||y==Y1+1||y==Y1+8))
					     break;
					    flagm=1;
					nptr=nptr->left;
					temp=nptr;
					nptr=nptr->right;
					nptr->left=temp->left;
					temp->left->right=nptr;
					free(temp);display();
					break;
			case KEY_DC :
			case 127: if(nptr!=tail)
				   {  
					flagm=1;
					if(dispptr==nptr)
					{ 
						nptr->c=nptr->right->c;
						if(nptr->right==tail) 
							tail=nptr;
						   temp=nptr->right;
						   nptr->right=temp->right;
						   temp->right->left=nptr; 
						   free(temp);
					}
					else 
					{
							temp=nptr;
							nptr=nptr->right;
							nptr->left=temp->left;
							temp->left->right=nptr;
							free(temp);
					}
				}
						display();
						break;
			case 27 :if(flagm==1)
					 savfile();
						
					bkgdset(' '|COLOR_BLACK);
					clear();
					refresh();
					endwin();
					exit(0);
					break;
			case KEY_F(2):
			case 5:		wi=2;
			case KEY_F(4):
			case 14:    if(ch==14||ch==KEY_F(4))
					    wi=4;
			case KEY_F(3):
			case 16:    if(ch==16||ch==KEY_F(3))
					    wi=3;
			case KEY_F(1):
			case 6:		if(ch==6||ch==KEY_F(1))
						wi=1;
						x3=1;
						drawwin(wi);
						keypad(wm,TRUE);
						ch1=wgetch(wm);
						flagx=0;
		while(ch1!='\n'&&flagx==0)
		{	
			switch(ch1)
			{	
				case KEY_UP: if(x3>1)
						     x3--;
					     else 
						     x3=wmax;
					delwin(wm);
					drawwin(wi);
					keypad(wm,TRUE);
					break;
				case KEY_DOWN: if(x3<wmax)
						       x3++;
					       else 
						       x3=1;
delwin(wm);
drawwin(wi);
keypad(wm,TRUE);
break;
				case KEY_RIGHT:if(wi<4)
						 wi++;
					       else 
						       wi=1;
delwin(wm);
clear();
display();
refresh();
x3=1;
drawwin(wi);
keypad(wm,TRUE);
break;
				case KEY_LEFT:if(wi>1)
						      wi--;
					      else 
						      wi=4;
delwin(wm);
clear();
display();
refresh();
x3=1;
drawwin(wi);
keypad(wm,TRUE);
break;
				case KEY_F(1): 
				case 27: 
				case 6:flagx=1;
				       break;
				}  
			if(flagx==0)
				ch1=wgetch(wm);
			} 
		delwin(wm);
		clear();
		display();
		refresh();
			if(flagx==0)
			{	
				switch(wi)
							{case 1:
		if(x3==1)
		{if(flagm==1)
		savfile();
		freenodes();
		strcpy(flname,"noname.txt");	flagm=0;}
		if(x3==2)
		{ if(flagm==1)savfile();
		w2=newwin(3,45,10,15);
			wattrset(w2,COLOR_PAIR(2));wbkgdset(w2,' '|COLOR_PAIR(2));wclear(w2);
			box(w2,0,0);
			mvwaddstr(w2,1,1,"Enter filename :");
			wrefresh(w2);echo();
			mvwscanw(w2,1,17,"%s",flnamet);noecho();
			f=fopen(flnamet,"r");
			if(f==NULL)
			{ mvwaddstr(w2,1,1,"Could not open file!                     ");
			wgetch(w2);	}
			else{ flagm=0;freenodes();strcpy(flname,flnamet);
			temp=head->right;
			while((a=getc(f))!=EOF)
			{insertnode(temp,a);temp=temp->right;}fclose(f);  }delwin(w2);}
		if(x3==4)
		{  w2=newwin(3,49,10,13);
			wattrset(w2,COLOR_PAIR(2));wbkgdset(w2,' '|COLOR_PAIR(2));wclear(w2);
			box(w2,0,0);
			mvwaddstr(w2,1,1,"Enter filename to saveas:");
			wrefresh(w2);echo();
			mvwscanw(w2,1,27,"%s",flname);noecho();
			f=fopen(flname,"w+");delwin(w2);
			if(f!=NULL)
			{ 	flagm=0;temp=head->right;
			while(temp!=tail)
			{	putc(temp->c,f);temp=temp->right;}
			fclose(f);}}
		if(x3==5)
		{	w2=newwin(3,45,10,15);
			wattrset(w2,COLOR_PAIR(2));wbkgdset(w2,' '|COLOR_PAIR(2));wclear(w2);
			box(w2,0,0);
			mvwaddstr(w2,1,1,"Enter file to delete:");
			wrefresh(w2);echo();
			mvwscanw(w2,1,22,"%s",flnamet);noecho();
			if(!remove(flnamet))
		{if(!strcpy(flnamet,flname))
		{
		freenodes();strcpy(flname,"noname.txt");flagm=0;}}
		else{mvwaddstr(w2,1,1,"Could not delete file!                   ");
			wgetch(w2);
		}delwin(w2);}				
									if(x3==6)
									{	if(flagm==1)
									savfile();
	bkgdset(' '|COLOR_BLACK);clear();refresh();endwin();exit(0);}
									if(x3==3)
									{	f=fopen(flname,"w+");
										if(f!=NULL){temp=head->right;flagm=0;
										while(temp!=tail)
										{
											putc(temp->c,f);
											temp=temp->right;
										}
										fclose(f);
									}} 
									break;
	case 2: if(x3==1)
		{ flagm=1;mtemp=nptr;
		while(mtemp->left!=head&&mtemp->left->c!='\n')
			mtemp=mtemp->left;
		nptr=mtemp;
		insertnode(nptr,'\n');}
		if(x3==2){if(x!=X1)
		{ flagm=1;mtemp=nptr;
		while(mtemp->left!=head&&mtemp->left->c!='\n')
			mtemp=mtemp->left;
		nptr=mtemp;
		while(nptr!=tail&&nptr->c!='\n')
		{  temp=nptr;nptr=nptr->right;
		nptr->left=temp->left;temp->left->right=nptr;
		free(temp);}
		if(nptr!=tail)
		{temp=nptr;nptr=nptr->right;
		nptr->left=temp->left;temp->left->right=nptr;
		free(temp);}}}
		if(x3==3){if(x!=X1)
		{flagm=1;while(nptr->left!=head&&nptr->left->c!='\n'&&nptr->left->c!=' ')
			nptr=nptr->left;
		while(nptr!=tail&&nptr->c!=' '&&nptr->c!='\n')
		{  temp=nptr;nptr=nptr->right;
		nptr->left=temp->left;temp->left->right=nptr;
		free(temp);}
		if(nptr!=tail)
		{temp=nptr;nptr=nptr->right;
		nptr->left=temp->left;temp->left->right=nptr;
		free(temp);}}}
		break;
	case 3:
		if(x3==1)
		{ w2=newwin(3,49,10,13);
			wattrset(w2,COLOR_PAIR(2));wbkgdset(w2,' '|COLOR_PAIR(2));wclear(w2);
			box(w2,0,0);
			mvwaddstr(w2,1,1,"Enter Left margin:");
			wrefresh(w2);echo();
			mvwscanw(w2,1,23,"%d",&Y1);noecho();
		Y1++;if(Y1>16)Y1=16;delwin(w2);}
		if(x3==2)
		{ w2=newwin(3,49,10,13);
			wattrset(w2,COLOR_PAIR(2));wbkgdset(w2,' '|COLOR_PAIR(2));wclear(w2);
			box(w2,0,0);
			mvwaddstr(w2,1,1,"Enter Right margin:");
			wrefresh(w2);echo();
			mvwscanw(w2,1,23,"%d",&Y2);noecho();
		if(Y2>16)Y2=16;Y2=COLS-Y2-2;delwin(w2);}
		if(x3==3)
		 nptr=dispptr=head->right;
		if(x3==4){nptr=dispptr=tail;
		 mtemp=dispptr;
		for(i=0;i<10;i++)
		{if(mtemp->left!=head)mtemp=mtemp->left;
		while(mtemp->left!=head&&mtemp->left->c!='\n')
				mtemp=mtemp->left;}
		dispptr=mtemp;}
		break;
	case 4: 	if(x3==1)
		{ 	w2=newwin(20,60,3,10);
			wattrset(w2,COLOR_PAIR(2));wbkgdset(w2,' '|COLOR_PAIR(2));wclear(w2);
			
mvwaddstr(w2,1,1,"                       A_EDIT HELP\n");
waddstr(w2,"                  File Menu   <ctrl-F> or F1\n");
waddstr(w2,"  New :opens a blank file   Open:opens specified file\n");
waddstr(w2,"  Save:saves file to disk   Save..as:filename specified\n");
waddstr(w2,"  Delete:Deletes file       Exit:exits program\n");
waddstr(w2,"                  Edit Menu   <ctrl-E> or F2\n");
waddstr(w2,"  Ins_line:Inserts a line above cursor position\n");
waddstr(w2,"  Del_line:Deletes line on which cursor is positioned\n");
waddstr(w2,"  Del_word:Deletes word on which cursor is positioned\n");
waddstr(w2,"                  Page_setup  <ctrl-P> or F3\n");
waddstr(w2,"  Left_margin:Specify number of charachters as margin\n");
waddstr(w2,"  Right_margin:Specify number of charachters as margin\n");
waddstr(w2,"  Begin:Moves cursor to beginning of file\n");
waddstr(w2,"  End:Move cursor to end of file\n");
waddstr(w2,"                  Help Menu   <ctrl-N> or F4\n");
waddstr(w2,"         A_EDIT  uses a linear doubly linked list data\n");
waddstr(w2,"  structure with each node containing one character.\n");
waddstr(w2,"            Press <ctrl-F> or F1 to close menu box      ");
		box(w2,0,0);
		wrefresh(w2);wgetch(w2);
			delwin(w2);}
	if(x3==2)aboutbox();					
		break;		}clear();display();refresh();		}	break;
		case 18:       /*ctrl-R*/
		case KEY_IC:if(insmd==1)insmd=0;
					else insmd=1;display();break;	
		case KEY_PPAGE:
		mtemp=nptr;for(i=0;i<22;i++){
		while(mtemp->left!=head&&mtemp->left->c!='\n')
				mtemp=mtemp->left;
	if(mtemp->left!=head)mtemp=mtemp->left;}dispptr=nptr=mtemp;clear();display();refresh();
				break;	
		case KEY_NPAGE:mtemp=nptr;for(i=0;i<21;i++)movedown();
							if(movedown())positionptr();nptr=mtemp;
					clear();display();refresh();break;
		case KEY_END:mtemp=nptr;while(mtemp!=tail&&mtemp->c!='\n')
					mtemp=mtemp->right;nptr=mtemp;display();break;
		case KEY_HOME:if(x==X1)nptr=dispptr;
		else { mtemp=nptr;while(mtemp->left!=head&&mtemp->left->c!='\n')
				mtemp=mtemp->left;nptr=mtemp;}display();break;
		default :flagm=1;if(insmd==1||nptr->c=='\n'){	insertnode(nptr,ch);
						nptr=nptr->right;}
						else{ if(nptr!=tail)
						{nptr->c=ch;nptr=nptr->right;}}
						display();
						
		}
	}
}
